#ifndef	_KBC_UTILS__H__INCLUDED__19_JULY_2001__
#define	_KBC_UTILS__H__INCLUDED__19_JULY_2001__

#include "UtilDefines.h"

// texture formats
#define TF_16BITRGB			2
#define TF_32BITRGB_ALPHA	4
#define	TF_32BITRGB			8
#define TF_24BITRGB			16


// shader type
#define SHADERTYPE_VERTEX	0x10
#define SHADERTYPE_PIXEL	0x20



void LogMsg(char *fmt,...) ;
void CloseLogFile() ;
const TCHAR* GetDXErrorEx(LPCTSTR start, const HRESULT hr) ;

BOOL InitVertexBuffer(LPDIRECT3DVERTEXBUFFER8* ppVB, 
					  const IDirect3DDevice8* device8, void* sourcePtr, const UINT cbSize, 
					  const DWORD dwVertexFormat, const DWORD dwUsage, const D3DPOOL d3dpool) ;
BOOL InitIndexBuffer(LPDIRECT3DINDEXBUFFER8* ppIB, 
					  const IDirect3DDevice8* device8, void* sourcePtr, const UINT cbSize, 
					  const DWORD dwVertexFormat, const DWORD dwUsage, const D3DPOOL d3dpool) ;

BOOL LoadAndCreateShader(LPDIRECT3DDEVICE8 m_pD3DDev, LPCTSTR filename, const DWORD* pDeclaration, 
							DWORD Usage, DWORD ShaderType, DWORD* pHandle) ;


BOOL LoadTexture(LPDIRECT3DTEXTURE8* ppTexture, LPDIRECT3DDEVICE8 device8, 
				 LPCTSTR lpszFilename, const BOOL bUseMipLevels,
				 const DWORD dwTextureFormat, const BOOL bCompressed) ;


void __fastcall SetYRotate(D3DMATRIX* mat, const float angleInRadians) ;


#endif	_KBC_UTILS__H__INCLUDED__19_JULY_2001__